Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class SaveDesign
	Inherits System.Windows.Forms.Form
	'Declarations for GETFILE.FRM
	
	Const TEXTFLAG As Short = 0
	Const FILEFLAG As Short = 1
	Const DIRFLAG As Short = 2
	
    Dim SelectFlag As Short
    Private IsInitializing As Boolean
	
	Private Sub Command1_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command1.Click
        Dim FileFrequency As String = ""
        Dim FileCurrent As String = ""
        Dim FileMainInput As String = ""
        Dim FileSelector As String = ""
        Dim FileMaterial As String = ""
        Dim FileCDvalue As String = ""
		Dim filename As String
        Dim CmfFile As String = ""
		'OK button; some errors can happen
		On Error GoTo ErrorTrap
		If SelectFlag = FILEFLAG Then
			CmfFile = File1.FileName
			'Text1.Text = CmfFile$
		End If
		'Was the last change to the filename in Text1?
		If SelectFlag = TEXTFLAG Then
			CmfFile = Text1.Text
			'We're done if FullPath was set
			If FullPath.Text <> "" Then
				On Error GoTo 0
				GoTo PathSet
			End If
			
			'Update directory list
			Dir1.Path = File1.Path
			
			'Was user only selecting a new directory?
		ElseIf SelectFlag = DIRFLAG Then 
			Dir1.Path = Dir1.DirList(Dir1.DirListIndex)
			Dir1_Change(Dir1, New System.EventArgs())
		End If
		'Set FullPath to selected file
		'Else
		If VB.Right(Dir1.Path, 1) = "\" Then
			FullPath.Text = Dir1.Path & CmfFile
		Else
			FullPath.Text = Dir1.Path & "\" & CmfFile
		End If
PathSet: 
		filename = FullPath.Text
		FileOpen(1, filename, OpenMode.Output)
		PrintLine(1, DateBox.Text)
		PrintLine(1, InfoBox.Text)
		PrintLine(1, FileCDvalue)
		PrintLine(1, FileMaterial)
		PrintLine(1, FileSelector)
		PrintLine(1, FileMainInput)
		PrintLine(1, FileCurrent)
		PrintLine(1, FileFrequency)
		'All done
		FileClose(1)
		Me.Close()
		ExitForm()
		'End If
		
		Exit Sub
		
ErrorTrap: 
		Beep()
		Resume Next
	End Sub
	
	Private Sub Command2_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Command2.Click
		'Cancel button; indicate by erasing FullPath
		FullPath.Text = ""
		
		'All done
		ExitForm()
	End Sub
	
	Private Sub Dir1_Change(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dir1.Change
		'User selected new subdirectory
		FillLabel1()
		
		'Update filename
		File1.FileName = Dir1.Path & "\" & File1.Pattern
		File1.Pattern = GetFileType()
		
		'Update drive list
		Drive1.Drive = Dir1.Path
		
		'Update name of file
		Text1.Text = File1.Pattern
		
		'Set last change to directory
		SelectFlag = DIRFLAG
	End Sub
	
	Private Sub Dir1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Dir1.SelectedIndexChanged
		'User clicked on new subdirectory
		SelectFlag = DIRFLAG
	End Sub
	
	Private Sub Drive1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Drive1.SelectedIndexChanged
		'User changed drive; update directory
		Dir1.Path = Drive1.Drive
		
		'Display current pattern
		Text1.Text = File1.Pattern
		
		'Set last change to directory
		SelectFlag = DIRFLAG
	End Sub
	
	Private Sub ExitForm()
		'User might want different patterns next time
		FileTypes.Items.Clear()
		
		'Don't unload, simply hide
		Me.Hide()
	End Sub
	
	Private Sub File1_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles File1.SelectedIndexChanged
		'User clicked on new filename
		Text1.Text = File1.FileName
		
		'Set last change to filename
		SelectFlag = FILEFLAG
	End Sub
	
	Private Sub File1_DoubleClick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles File1.DoubleClick
		'User double-clicked on a filename
		Command1_Click(Command1, New System.EventArgs())
	End Sub
	
	Private Sub File1_PathChange(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles File1.PathChange
		'Update filename
		File1.FileName = Dir1.Path & "\" & File1.Pattern
		File1.Pattern = GetFileType()
		'Update drive list
		Drive1.Drive = Dir1.Path
		
		
		
	End Sub
	
	Private Sub FileTypes_SelectedIndexChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles FileTypes.SelectedIndexChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            'User selected new pattern from combo box
            File1.Pattern = GetFileType()

            'Display pattern until a file is selected
            Text1.Text = File1.Pattern
        End If
    End Sub
	
	Private Sub FillLabel1()
		Dim b As String
		Dim a As String
		'Display directory part of path
		Label1.Text = Dir1.Path
		
		'If directory string is too long, squish it down
		If VB6.PixelsToTwipsX(Label1.Width) > 2200 Then
			
			'Extract drive part
			a = VB.Left(Dir1.Path, 3)
			b = Mid(Dir1.Path, 4)
			
			'Extract last subdirectory part
			Do While InStr(b, "\")
				b = Mid(b, InStr(b, "\") + 1)
			Loop 
			
			'Squish out middle part
			Label1.Text = a & "...\" & b
		End If
	End Sub
	
	Private Sub SaveDesign_Activated(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Activated
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            'Don't select any filename at first
            File1.SelectedIndex = -1

            'If no pattern list, default to *.CMF
            If FileTypes.Items.Count = 0 Then
                FileTypes.Items.Add("Design Files (*.CMF)")
                FileTypes.Items.Add("All Files (*.*)")
            End If

            'Default to first pattern in list
            FileTypes.SelectedIndex = 0

            'If no previous path, use application's path
            If FullPath.Text = "" Then
                FullPath.Text = My.Application.Info.DirectoryPath & "\"
            End If

            'Update lists and labels
            File1.Pattern = GetFileType()
            Text1.Text = File1.Pattern
            Dir1.Path = File1.Path
            FillLabel1()
            SelectFlag = DIRFLAG
            FullPath.Text = ""
        End If
    End Sub
	
	Private Sub SaveDesign_KeyUp(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.KeyEventArgs) Handles MyBase.KeyUp
		Dim KeyCode As Short = eventArgs.KeyCode
		Dim Shift As Short = eventArgs.KeyData \ &H10000
		'Watch only for Alt plus N, D, T or V key
		If Shift = 4 Then
			Select Case KeyCode
				
				'Alt+N
				Case 78
					Text1.Focus()
					
					'Alt+D
				Case 68
					Dir1.Focus()
					
					'Alt+T
				Case 84
					FileTypes.Focus()
					
					'Alt+V
				Case 86
					Drive1.Focus()
					
			End Select
		End If
	End Sub
	
	Private Sub SaveDesign_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
		'Center form on screen
		Me.Left = VB6.TwipsToPixelsX((VB6.PixelsToTwipsX(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width) - VB6.PixelsToTwipsX(Me.Width)) / 2)
		Me.Top = VB6.TwipsToPixelsY((VB6.PixelsToTwipsY(System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height) - VB6.PixelsToTwipsY(Me.Height)) / 2)
		DateBox.Text = DateString
		Text1.TabStop = True
	End Sub
	
	Private Function GetFileType() As String
		Dim p2 As Object
		Dim p1 As Object
		Dim Tmp As String
		'Get pattern description from combo box
		Tmp = FileTypes.Text
		
		'Find position of parentheses
		p1 = InStr(Tmp, "(") + 1
		p2 = InStr(Tmp, ")")
		
		'Return part between parentheses
		If p1 > 0 And p2 > p1 Then
            GetFileType = LCase(Mid(Tmp, p1, p2 - p1))
        Else
            GetFileType = "*.*"
        End If
	End Function
	
	Private Sub Text1_TextChanged(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Text1.TextChanged
        If Me.IsInitializing = True Then
            Exit Sub
        Else
            'Set last change to File Name field
            SelectFlag = TEXTFLAG
        End If
    End Sub
End Class